
#pragma once

#ifndef NDEBUG

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <execinfo.h>
#include <dlfcn.h>
#include <link.h>
#include <linux/types.h>
#include <execinfo.h>
#include <cxxabi.h>

// THe PACKAGE and PACKAGE_VERSION macros are needed for bfd.h,
// see https://stackoverflow.com/a/11748919
#define PACKAGE
#define PACKAGE_VERSION
#include <bfd.h>
#undef PACKAGE
#undef PACKAGE_VERSION


//from: https://oroboro.com/printing-stack-traces-file-line/


typedef char 				s8;
typedef short 				s16;
typedef int 				s32;

typedef unsigned char 		u8;
typedef unsigned short 		u16;
typedef unsigned int 		u32;

#endif

namespace TNL {
namespace Debugging {

#ifndef NDEBUG

class FileMatch 
{
public:
   FileMatch( void* addr );
 
   void*       mAddress;
   const char* mFile;
   void*       mBase;
};

class FileLineDesc
{
public:
   FileLineDesc( asymbol** syms, bfd_vma pc ); 

   void findAddressInSection( bfd* abfd, asection* section );
 
   bfd_vma      mPc;
   char*        mFilename;
   char*        mFunctionname;
   unsigned int mLine;
   int          mFound;
   asymbol**    mSyms;
};

int findMatchingFile( struct dl_phdr_info* info, size_t size, void* data );
asymbol** kstSlurpSymtab( bfd* abfd, const char* fileName );
void FindAddressInSection( bfd* abfd, asection* section, void* data );
char** translateAddressesBuf( bfd* abfd, bfd_vma* addr, int numAddr, asymbol** syms );
char** processFile( const char* fileName, bfd_vma* addr, int naddr );
char** backtraceSymbols( void* const* addrList, int numAddr );
void printStackBacktraceWithLines( FILE *out = stderr, unsigned int max_frames = 63 );


#endif

} // namespace Debugging
} // namespace TNL

#ifdef NDEBUG
#define PrintStackBacktraceWithLines
#else
#define PrintStackBacktraceWithLines TNL::Debugging::printStackBacktraceWithLines();
#endif
